from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Boolean, Float, Int

Clustermasstracesbyprecursor_V0_1_0 = CommandToolBuilder(tool="ClusterMassTracesByPrecursor", base_command=["ClusterMassTracesByPrecursor"], inputs=[ToolInput(tag="in_in_ms_one", input_type=File(optional=True), prefix="-in_ms1", doc=InputDocumentation(doc="*                    MS1 mass traces (valid formats: 'consensusXML')")), ToolInput(tag="in_in_swath", input_type=File(optional=True), prefix="-in_swath", doc=InputDocumentation(doc="*                  MS2 / SWATH mass traces (valid formats: 'consensusXML')")), ToolInput(tag="in_out", input_type=File(optional=True), prefix="-out", doc=InputDocumentation(doc="*                       Output file (valid formats: 'mzML')")), ToolInput(tag="in_assign_unassigned_to_all", input_type=Boolean(optional=True), prefix="-assign_unassigned_to_all", doc=InputDocumentation(doc="Assign unassigned MS2 fragments to all precursors (only for ms1_centrif)")), ToolInput(tag="in_min_pearson_correlation", input_type=Float(optional=True), prefix="-min_pearson_correlation", doc=InputDocumentation(doc="Minimal pearson correlation score to match elution profiles to each other. (default: '0.7')")), ToolInput(tag="in_max_lag", input_type=Int(optional=True), prefix="-max_lag", doc=InputDocumentation(doc="Maximal lag (e.g. by how many spectra the peak may be shifted at most). This parameter will depend on your chromatographic setup but a number between 1 and 3 is usually sensible. (default: '1')")), ToolInput(tag="in_min_nr_ions", input_type=Int(optional=True), prefix="-min_nr_ions", doc=InputDocumentation(doc="Minimal number of ions to report a spectrum. (default: '3')")), ToolInput(tag="in_max_rt_apex_difference", input_type=Float(optional=True), prefix="-max_rt_apex_difference", doc=InputDocumentation(doc="Maximal difference of the apex in retention time (in seconds). This is a hard parameter, all profiles further away will not be considered at all. (default: '5.0')")), ToolInput(tag="in_swath_lower", input_type=Float(optional=True), prefix="-swath_lower", doc=InputDocumentation(doc="Swath lower isolation window (default: '0.0')")), ToolInput(tag="in_swath_upper", input_type=Float(optional=True), prefix="-swath_upper", doc=InputDocumentation(doc="Swath upper isolation window (default: '0.0')")), ToolInput(tag="in_ini", input_type=File(optional=True), prefix="-ini", doc=InputDocumentation(doc="Use the given TOPP INI file")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="-threads", doc=InputDocumentation(doc="Sets the number of threads allowed to be used by the TOPP tool (default: '1')")), ToolInput(tag="in_write_ini", input_type=File(optional=True), prefix="-write_ini", doc=InputDocumentation(doc="Writes the default configuration file")), ToolInput(tag="in_helphelp", input_type=Boolean(optional=True), prefix="--helphelp", doc=InputDocumentation(doc="Shows all options (including advanced)"))], outputs=[ToolOutput(tag="out_out", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out", type_hint=File()), doc=OutputDocumentation(doc="*                       Output file (valid formats: 'mzML')"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Clustermasstracesbyprecursor_V0_1_0().translate("wdl", allow_empty_container=True)

